/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "./environments";
import * as core from "./core";
import { Prompts } from "./api/resources/prompts/client/Client";
import { Tools } from "./api/resources/tools/client/Client";
import { Datasets } from "./api/resources/datasets/client/Client";
import { Evaluators } from "./api/resources/evaluators/client/Client";
import { Flows } from "./api/resources/flows/client/Client";
import { Directories } from "./api/resources/directories/client/Client";
import { Files } from "./api/resources/files/client/Client";
import { Evaluations } from "./api/resources/evaluations/client/Client";
import { Logs } from "./api/resources/logs/client/Client";
export declare namespace HumanloopClient {
    interface Options {
        environment?: core.Supplier<environments.HumanloopEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class HumanloopClient {
    protected readonly _options: HumanloopClient.Options;
    protected _prompts: Prompts | undefined;
    protected _tools: Tools | undefined;
    protected _datasets: Datasets | undefined;
    protected _evaluators: Evaluators | undefined;
    protected _flows: Flows | undefined;
    protected _directories: Directories | undefined;
    protected _files: Files | undefined;
    protected _evaluations: Evaluations | undefined;
    protected _logs: Logs | undefined;
    constructor(_options?: HumanloopClient.Options);
    get prompts(): Prompts;
    get tools(): Tools;
    get datasets(): Datasets;
    get evaluators(): Evaluators;
    get flows(): Flows;
    get directories(): Directories;
    get files(): Files;
    get evaluations(): Evaluations;
    get logs(): Logs;
}
