/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Humanloop from "../../../../index";
/**
 * @example
 *     {
 *         path: "test-questions",
 *         datapoints: [{
 *                 inputs: {
 *                     "question": "What is the capital of France?"
 *                 },
 *                 target: {
 *                     "answer": "Paris"
 *                 }
 *             }, {
 *                 inputs: {
 *                     "question": "Who wrote Hamlet?"
 *                 },
 *                 target: {
 *                     "answer": "William Shakespeare"
 *                 }
 *             }],
 *         action: "set",
 *         versionName: "test-questions-v1",
 *         versionDescription: "Add two new questions and answers"
 *     }
 *
 * @example
 *     {
 *         path: "datasets/support-queries",
 *         datapoints: [{
 *                 messages: [{
 *                         role: "user",
 *                         content: "How do i manage my organizations API keys?\n"
 *                     }],
 *                 target: {
 *                     "response": "Hey, thanks for your questions. Here are steps for how to achieve: 1. Log in to the Humanloop Dashboard \n\n2. Click on \"Organization Settings.\"\n If you do not see this option, you might need to contact your organization admin to gain the necessary permissions.\n\n3. Within the settings or organization settings, select the option labeled \"API Keys\" on the left. Here you will be able to view and manage your API keys.\n\n4. You will see a list of existing API keys. You can perform various actions, such as:\n     - **Generate New API Key:** Click on the \"Generate New Key\" button if you need a new API key.\n     - **Revoke an API Key:** If you need to disable an existing key, find the key in the list and click the \"Revoke\" or \"Delete\" button.\n     - **Copy an API Key:** If you need to use an existing key, you can copy it to your clipboard by clicking the \"Copy\" button next to the key.\n\n5. **Save and Secure API Keys:** Make sure to securely store any new or existing API keys you are using. Treat them like passwords and do not share them publicly.\n\nIf you encounter any issues or need further assistance, it might be helpful to engage with an engineer or your IT department to ensure you have the necessary permissions and support.\n\nWould you need help with anything else?"
 *                 }
 *             }, {
 *                 messages: [{
 *                         role: "user",
 *                         content: "Hey, can do I use my code evaluator for monitoring my legal-copilot prompt?"
 *                     }],
 *                 target: {
 *                     "response": "Hey, thanks for your questions. Here are steps for how to achieve: 1. Navigate to your Prompt dashboard. \n 2. Select the `Monitoring` button on the top right of the Prompt dashboard \n 3. Within the model select the Version of the Evaluator you want to turn on for monitoring. \n\nWould you need help with anything else?"
 *                 }
 *             }],
 *         versionName: "Initial version",
 *         versionDescription: "Add two new questions and answers"
 *     }
 */
export interface DatasetRequest {
    /**
     * ID of the specific Dataset version to base the created Version on. Only used when `action` is `"add"` or `"remove"`.
     */
    versionId?: string;
    /**
     * Name of the Environment identifying a deployed Version to base the created Version on. Only used when `action` is `"add"` or `"remove"`.
     */
    environment?: string;
    /**
     * If set to `true`, include all Datapoints in the response. Defaults to `false`. Consider using the paginated List Datapoints endpoint instead.
     */
    includeDatapoints?: boolean;
    /** Path of the Dataset, including the name. This locates the Dataset in the Humanloop filesystem and is used as as a unique identifier. For example: `folder/name` or just `name`. */
    path?: string;
    /** ID for an existing Dataset. */
    id?: string;
    /** The Datapoints to create this Dataset version with. Modify the `action` field to determine how these Datapoints are used. */
    datapoints: Humanloop.CreateDatapointRequest[];
    /**
     * The action to take with the provided Datapoints.
     *
     *  - If `"set"`, the created version will only contain the Datapoints provided in this request.
     *  - If `"add"`, the created version will contain the Datapoints provided in this request in addition to the Datapoints in the target version.
     *  - If `"remove"`, the created version will contain the Datapoints in the target version except for the Datapoints provided in this request.
     *
     * If `"add"` or `"remove"`, one of the `version_id` or `environment` query parameters may be provided.
     */
    action?: Humanloop.UpdateDatesetAction;
    /** Additional fields to describe the Dataset. Helpful to separate Dataset versions from each other with details on how they were created or used. */
    attributes?: Record<string, unknown>;
    /** Unique name for the Dataset version. Version names must be unique for a given Dataset. */
    versionName?: string;
    /** Description of the version, e.g., the changes made in this version. */
    versionDescription?: string;
}
