/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Humanloop from "../../../index";
export declare namespace Directories {
    interface Options {
        environment?: core.Supplier<environments.HumanloopEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey?: core.Supplier<string>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Directories {
    protected readonly _options: Directories.Options;
    constructor(_options?: Directories.Options);
    /**
     * Retrieve a list of all Directories.
     *
     * @param {Directories.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Humanloop.UnprocessableEntityError}
     *
     * @example
     *     await client.directories.list()
     */
    list(requestOptions?: Directories.RequestOptions): Promise<Humanloop.DirectoryResponse[]>;
    /**
     * Creates a Directory.
     *
     * @param {Humanloop.CreateDirectoryRequest} request
     * @param {Directories.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Humanloop.UnprocessableEntityError}
     *
     * @example
     *     await client.directories.create()
     */
    create(request?: Humanloop.CreateDirectoryRequest, requestOptions?: Directories.RequestOptions): Promise<Humanloop.DirectoryResponse>;
    /**
     * Fetches a directory by ID.
     *
     * @param {string} id - String ID of directory. Starts with `dir_`.
     * @param {Directories.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Humanloop.UnprocessableEntityError}
     *
     * @example
     *     await client.directories.get("id")
     */
    get(id: string, requestOptions?: Directories.RequestOptions): Promise<Humanloop.DirectoryWithParentsAndChildrenResponse>;
    /**
     * Delete the Directory with the given ID.
     *
     * The Directory must be empty (i.e. contain no Directories or Files).
     *
     * @param {string} id - Unique identifier for Directory. Starts with `dir_`.
     * @param {Directories.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Humanloop.UnprocessableEntityError}
     *
     * @example
     *     await client.directories.delete("id")
     */
    delete(id: string, requestOptions?: Directories.RequestOptions): Promise<void>;
    /**
     * Update the Directory with the given ID.
     *
     * @param {string} id - Unique identifier for Directory. Starts with `dir_`.
     * @param {Humanloop.UpdateDirectoryRequest} request
     * @param {Directories.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Humanloop.UnprocessableEntityError}
     *
     * @example
     *     await client.directories.update("id")
     */
    update(id: string, request?: Humanloop.UpdateDirectoryRequest, requestOptions?: Directories.RequestOptions): Promise<Humanloop.DirectoryResponse>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "X-API-KEY": string | undefined;
    }>;
}
