/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Humanloop from "../../../../index";
/**
 * @example
 *     {
 *         path: "math-tool",
 *         function: {
 *             name: "multiply",
 *             description: "Multiply two numbers",
 *             parameters: {
 *                 "type": "object",
 *                 "properties": {
 *                     "a": {
 *                         "type": "number"
 *                     },
 *                     "b": {
 *                         "type": "number"
 *                     }
 *                 },
 *                 "required": [
 *                     "a",
 *                     "b"
 *                 ]
 *             }
 *         },
 *         versionName: "math-tool-v1",
 *         versionDescription: "Simple math tool that multiplies two numbers"
 *     }
 */
export interface ToolRequest {
    /** Path of the Tool, including the name. This locates the Tool in the Humanloop filesystem and is used as as a unique identifier. For example: `folder/name` or just `name`. */
    path?: string;
    /** ID for an existing Tool. */
    id?: string;
    /** Callable function specification of the Tool shown to the model for tool calling. */
    function?: Humanloop.ToolFunction;
    /** Code source of the Tool. */
    sourceCode?: string;
    /** Values needed to setup the Tool, defined in JSON Schema format: https://json-schema.org/ */
    setupValues?: Record<string, unknown>;
    /** Additional fields to describe the Tool. Helpful to separate Tool versions from each other with details on how they were created or used. */
    attributes?: Record<string, unknown>;
    /** Type of Tool. */
    toolType?: Humanloop.FilesToolType;
    /** Unique identifier for this Tool version. Each Tool can only have one version with a given name. */
    versionName?: string;
    /** Description of the Version. */
    versionDescription?: string;
}
