/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Humanloop from "../index";
/**
 * Response model for a Flow.
 */
export interface FlowResponse {
    /** Path of the Flow, including the name, which is used as a unique identifier. */
    path: string;
    /** Unique identifier for the Flow. */
    id: string;
    /** ID of the directory that the file is in on Humanloop. */
    directoryId?: string;
    /** A key-value object identifying the Flow Version. */
    attributes: Record<string, unknown>;
    /** Unique name for the Flow version. Version names must be unique for a given Flow. */
    versionName?: string;
    /** Description of the Version. */
    versionDescription?: string;
    /** Name of the Flow. */
    name: string;
    /** Description of the Flow. */
    description?: string;
    /** Long description of the file. */
    readme?: string;
    /** List of tags associated with the file. */
    tags?: string[];
    /** Unique identifier for the specific Flow Version. If no query params provided, the default deployed Flow Version is returned. */
    versionId: string;
    type?: "flow";
    /** The list of environments the Flow Version is deployed to. */
    environments?: Humanloop.EnvironmentResponse[];
    createdAt: Date;
    updatedAt: Date;
    /** The user who created the Flow. */
    createdBy?: Humanloop.UserResponse | undefined;
    lastUsedAt: Date;
    /** The number of logs that have been generated for this Flow Version */
    versionLogsCount: number;
    /** Aggregation of Evaluator results for the Flow Version. */
    evaluatorAggregates?: Humanloop.EvaluatorAggregate[];
    /** The list of Monitoring Evaluators associated with the Flow Version. */
    evaluators?: Humanloop.MonitoringEvaluatorResponse[];
}
