/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         path: "Personal Projects/MedQA Flow",
 *         attributes: {
 *             "prompt": {
 *                 "template": "You are a helpful medical assistant helping with medical anamnesis. Answer {{question}}",
 *                 "model": "gpt-4o",
 *                 "temperature": 0.8
 *             },
 *             "tool": {
 *                 "name": "retrieval_tool_v3",
 *                 "description": "Retrieval tool for MedQA.",
 *                 "source_code": "def retrieval_tool(question: str) -> str:\n    pass\n"
 *             },
 *             "version_name": "medqa-flow-v1",
 *             "version_description": "Initial version"
 *         }
 *     }
 */
export interface FlowRequest {
    /** Path of the Flow, including the name. This locates the Flow in the Humanloop filesystem and is used as as a unique identifier. For example: `folder/name` or just `name`. */
    path?: string;
    /** ID for an existing Flow. */
    id?: string;
    /** A key-value object identifying the Flow Version. */
    attributes: Record<string, unknown>;
    /** Unique name for the Flow version. Version names must be unique for a given Flow. */
    versionName?: string;
    /** Description of the version, e.g., the changes made in this version. */
    versionDescription?: string;
}
