/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Humanloop from "../../../../index";
/**
 * @example
 *     {
 *         fileId: "file_123abc",
 *         size: 1
 *     }
 */
export interface ListLogsGetRequest {
    /**
     * Unique identifier for the File to list Logs for.
     */
    fileId: string;
    /**
     * Page number for pagination.
     */
    page?: number;
    /**
     * Page size for pagination. Number of Logs to fetch.
     */
    size?: number;
    /**
     * If provided, only Logs belonging to the specified Version will be returned.
     */
    versionId?: string;
    /**
     * If provided, only Logs belonging to Versions with the specified status will be returned.
     */
    versionStatus?: Humanloop.VersionStatus;
    /**
     * If provided, returns Logs whose IDs contain any of the specified values as substrings.
     */
    id?: string | string[];
    /**
     * If provided, only Logs that contain the provided string in its inputs and output will be returned.
     */
    search?: string;
    /**
     * If provided, only Logs that contain the provided string in its metadata will be returned.
     */
    metadataSearch?: string;
    /**
     * If provided, only Logs created after the specified date will be returned.
     */
    startDate?: Date;
    /**
     * If provided, only Logs created before the specified date will be returned.
     */
    endDate?: Date;
    /**
     * If true, include the full parent Log in the response. Only applicable when retrieving Evaluator Logs.
     */
    includeParent?: boolean;
    /**
     * If true, return Logs that are associated to a Trace. False, return Logs that are not associated to a Trace.
     */
    inTraceFilter?: boolean | boolean[];
    /**
     * If provided, limit the response to a random subset of logs from the filtered results. (This will be an approximate sample, not a strict limit.)
     */
    sample?: number;
    /**
     * If true, populate `trace_children` for the retrieved Logs. Only applicable when retrieving Flow Logs.
     */
    includeTraceChildren?: boolean;
}
