/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Humanloop from "../index";
/**
 * Base type that all File Responses should inherit from.
 *
 * Attributes defined here are common to all File Responses and should be overridden
 * in the inheriting classes with documentation and appropriate Field definitions.
 */
export interface DatasetResponse {
    /** Path of the Dataset, including the name, which is used as a unique identifier. */
    path: string;
    /** Unique identifier for the Dataset. Starts with `ds_`. */
    id: string;
    /** ID of the directory that the file is in on Humanloop. */
    directoryId?: string;
    /** Name of the Dataset, which is used as a unique identifier. */
    name: string;
    /** Description of the Dataset. */
    description?: string;
    /** Long description of the file. */
    readme?: string;
    /** List of tags associated with the file. */
    tags?: string[];
    /** Unique identifier for the specific Dataset Version. If no query params provided, the default deployed Dataset Version is returned. Starts with `dsv_`. */
    versionId: string;
    type?: "dataset";
    /** The list of environments the Dataset Version is deployed to. */
    environments?: Humanloop.EnvironmentResponse[];
    createdAt: Date;
    updatedAt: Date;
    /** The user who created the Dataset. */
    createdBy?: Humanloop.UserResponse | undefined;
    lastUsedAt: Date;
    /** Unique name for the Dataset version. Version names must be unique for a given Dataset. */
    versionName?: string;
    /** Description of the version, e.g., the changes made in this version. */
    versionDescription?: string;
    /** The number of Datapoints in this Dataset version. */
    datapointsCount: number;
    /** The list of Datapoints in this Dataset version. Only provided if explicitly requested. */
    datapoints?: Humanloop.DatapointResponse[];
    /** Additional fields to describe the Dataset. Helpful to separate Dataset versions from each other with details on how they were created or used. */
    attributes?: Record<string, unknown>;
}
