import * as otel_api from "@opentelemetry/api";
import { AsyncHooksContextManager } from "@opentelemetry/context-async-hooks";
export declare const HL_CONTEXT: AsyncHooksContextManager;
export declare function getTraceId(): string | undefined;
export declare function setTraceId(flowLogId: string): otel_api.Context;
export type DecoratorContext = {
    path: string;
    type: "prompt" | "tool" | "flow";
    version: Record<string, unknown>;
};
export declare function setDecoratorContext(decoratorContext: DecoratorContext): otel_api.Context;
export declare function getDecoratorContext(): DecoratorContext | undefined;
export declare class EvaluationContext {
    sourceDatapointId: string;
    runId: string;
    fileId: string;
    path: string;
    private _logged;
    private _callback;
    constructor({ sourceDatapointId, runId, evalCallback, fileId, path, }: {
        sourceDatapointId: string;
        runId: string;
        evalCallback: (log_id: string) => Promise<void>;
        fileId: string;
        path: string;
    });
    get logged(): boolean;
    logArgsWithContext({ logArgs, forOtel, path, fileId, }: {
        logArgs: Record<string, any>;
        forOtel: boolean;
        path?: string;
        fileId?: string;
    }): [Record<string, any>, ((log_id: string) => Promise<void>) | null];
}
export declare function setEvaluationContext(evaluationContext: EvaluationContext): otel_api.Context;
export declare function getEvaluationContext(): EvaluationContext | undefined;
