export type AnyValue = {
    stringValue?: string;
    boolValue?: boolean;
    intValue?: number;
    doubleValue?: number;
    arrayValue?: ArrayValue;
    kvlistValue?: KeyValueList;
    bytesValue?: Uint8Array;
};
export type ArrayValue = {
    values: AnyValue[];
};
export type KeyValueList = {
    values: KeyValue[];
};
export type KeyValue = {
    key: string;
    value: AnyValue;
};
export type InstrumentationScope = {
    name: string;
    version?: string;
    attributes?: KeyValue[];
    droppedAttributesCount?: number;
};
